image: "rust:latest"

stages:
  - check
  - build
  - test

cache:
  paths:
    - ./target/debug

variables:
  CRATE_NAME: ""

check_code:
  stage: check
  when: manual
  script:
    - rustc --version && cargo --version
    - cargo check --verbose

build:
  stage: build
  when: manual
  script:
    - rustc --version && cargo --version
    - cargo build --verbose
    - ./target/debug/$CRATE_NAME
    #- du -h ./*
    #- ls ./target/debug/*
    #- cat Cargo.lock

test:
  stage: test
  when: manual
  script:
    - rustc --version && cargo --version
    - cargo test --all --verbose
